<?php

namespace Drupal\edit_plus_sweet\EventSubscriber;

use Drupal\lb_plus\Event\PlaceBlockEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class Heading implements EventSubscriberInterface {

  public function onPostPlaceBlockFormBuild(PlaceBlockEvent $event) {
    if ($event->getBlockPluginId() === 'inline_block' && $event->getBundle() === 'heading') {
      $block_plugin = $event->getBlockPlugin();
      $configuration = $block_plugin->getConfiguration();
      $configuration['label_display'] = 'visible';
      $configuration['label'] = $block_plugin->label();
      $configuration['label_tag'] = 'h2';
      $block_plugin->setConfiguration($configuration);
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return [
      PlaceBlockEvent::class => ['onPostPlaceBlockFormBuild'],
    ];
  }

}
