<?php

namespace Drupal\edit_plus_sweet\EventSubscriber\LayoutBuilderBlockForm;

use Drupal\Core\Form\FormStateInterface;
use Drupal\edit_plus_sweet\Events\LayoutBuilderBlockFormAlterEvent;

/**
 * Alters the block form of the 'image' custom block bundle.
 */
class ImageCustomizations extends LayoutBuilderBlockFormBase {

  /**
   * {@inheritdoc}
   */
  public $blockId = 'image';

  /**
   * {@inheritdoc}
   */
  public function formAlter(LayoutBuilderBlockFormAlterEvent $event) {
    $form = $event->getForm();
    $config = $event->getConfiguration();
    $form['horizontal_alignment'] = [
      '#type' => 'select',
      '#title' => t('Alignment'),
      '#options' => [
        'left' => t('Left'),
        'center' => t('Center'),
        'right' => t('Right'),
      ],
      '#default_value' => !empty($config['horizontal_alignment']) ? $config['horizontal_alignment'] : 'left',
      '#attributes' => ['data-edit-plus-auto-submit' => ''],
    ];
    $form['#submit'] = array_merge([[$this, 'formSubmit']], $form['#submit']);
    $event->setForm($form);
  }

  public function formSubmit(array &$form, FormStateInterface $form_state) {
    $form_object = $form_state->getFormObject();
    $p = new \ReflectionProperty($form_object, 'block');
    $p->setAccessible(TRUE);
    /** @var \Drupal\Component\Plugin\ConfigurableInterface $component */
    $component = $p->getValue($form_object);
    $config = $component->getConfiguration();
    $config['horizontal_alignment'] = $form_state->getValue('horizontal_alignment');
    $component->setConfiguration($config);
  }

}
