<?php

namespace Drupal\edit_plus_sweet\EventSubscriber\LayoutBuilderBlockForm;

use Drupal\edit_plus_sweet\Events\LayoutBuilderBlockFormAlterEvent;
use Drupal\layout_builder\LayoutBuilderEvents;

class TitleCustomizations extends EnhancedTitleBase {

  public $blockId = 'field_block:node:landing_page:title';

  public static function getSubscribedEvents() {
    $events = parent::getSubscribedEvents();
    $events[LayoutBuilderEvents::SECTION_COMPONENT_BUILD_RENDER_ARRAY] = ['onBuildRender', 90];
    return $events;
  }


  public function formAlter(LayoutBuilderBlockFormAlterEvent $event) {
    parent::formAlter($event);
    $form = $event->getForm();
    if ($form['settings']['label']['#default_value'] === "Title") {
      $form['settings']['label']['#value'] = "Page Title";
    }
    $form['settings']['label']['#access'] = FALSE;
    $form['settings']['label_display']['#value'] = FALSE;
    $form['settings']['label_display']['#access'] = FALSE;
    $form['settings']['formatter']['label']['#value'] = 'hidden';
    $form['settings']['formatter']['label']['#access'] = FALSE;

    $form['title_size']['#states'] = [
      'visible' => [
        ':input[name="settings[formatter][type]"]' => ['value' => 'heading'],
      ],
    ];
    $form['title_color']['#states'] = [
      'visible' => [
        ':input[name="settings[formatter][type]"]' => ['value' => 'heading'],
      ],
    ];
    $form['first_color']['#states']['visible'][] = [
      ':input[name="settings[formatter][type]"]' => ['value' => 'heading'],
    ];
    $form['second_color']['#states']['visible'][] = [
      ':input[name="settings[formatter][type]"]' => ['value' => 'heading'],
    ];
    $form['gradient_rotation']['#states']['visible'][] = [
      ':input[name="settings[formatter][type]"]' => ['value' => 'heading'],
    ];

    $event->setForm($form);
  }

}
